/'****************************************************************************
*
* Name: teststack.bas
*
* Synopsis: A test program for the stack object.
*
* Description: This program excersises the members of the stack object. 
*
* Copyright 2009, Richard D. Clark
*
*                          The Wide Open License (WOL)
*
* Permission to use, copy, modify, distribute and sell this software and its
* documentation for any purpose is hereby granted without fee, provided that
* the above copyright notice and this license appear in all source copies. 
* THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF
* ANY KIND. See http://www.dspguru.com/wol.htm for more information.
*
*****************************************************************************'/

#Include "fbstack.bi"

Dim myStack As fbStackarr.stackobj
Dim myData As fbstackarr.dataobj
Dim As Integer ret, i, ss, dt
Dim As fbStackarr.stackerror serror
'Add some integers to the stack.
ss = myStack.StackSize
'Will generate an error with last items since number of items is greater than stack size.
For i = 1 To ss + 1
	myData = i
	ret = myStack.Push(myData)
	If ret = FALSE Then
		serror = myStack.GetLastError
		Print "Error code: " & serror & ". " & myStack.GetErrorMessage(serror) & "."
		Exit For
	Else
		Print "Added " & i & " to the stack."
	EndIf
Next
Print
'Pop the items from the stack.
ss = myStack.Count
Print "There are " & ss & " items on the stack."
Print
'Will generate an error on last item since stack will be empty.
For i As Integer = ss To -1 Step -1
	ret = myStack.Pop(myData)
	If ret = FALSE Then
		serror = myStack.GetLastError
		Print "Error code: " & serror & ". " & myStack.GetErrorMessage(serror) & "."
		Exit For
	Else
		dt = myData
		Print "Popped " & dt & " from the stack."
	EndIf
Next
Print
Print "Stack count: " & myStack.Count & "."
Sleep
