/'****************************************************************************
*
* Name: teststack.bas
*
* Synopsis: A test program for the stack object.
*
* Description: This program excersises the members of the stack object. 
*
* Copyright 2009, Richard D. Clark
*
*                          The Wide Open License (WOL)
*
* Permission to use, copy, modify, distribute and sell this software and its
* documentation for any purpose is hereby granted without fee, provided that
* the above copyright notice and this license appear in all source copies. 
* THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF
* ANY KIND. See http://www.dspguru.com/wol.htm for more information.
*
*****************************************************************************'/

#Include "fbstack.bi"

Dim myStack As fbStack.stackobj
Dim myData As fbstack.dataobj
Dim As Integer ret, i
Dim As fbStack.stackerror serror

'Add 10 integers to the stack.
For i = 1 To 10
	myData = i
	ret = myStack.Push(myData)
	If ret = FALSE Then
		serror = myStack.GetLastError
		Print "Error code: " & serror & ". " & myStack.GetErrorMessage(serror) & "."
		Exit For
	Else
		Print "Added " & i & " to the stack."
	EndIf
Next
Print
'Pop the items from the stack.
i = myStack.Count
Print "There are " & i & " items on the stack."
Print
'Will generate an error on last items since stack will be empty.
Do While myStack.Count > -1
	ret = myStack.Pop(myData)
	If ret = FALSE Then
		serror = myStack.GetLastError
		Print "Error code: " & serror & ". " & myStack.GetErrorMessage(serror) & "."
		Exit Do
	Else
		i = myData
		Print "Popped " & i & " from the stack."
	EndIf
Loop
Print
Print "Stack count: " & myStack.Count & "."
Sleep
